// Kustom Magic Software, Copyright (c) 1995, Ralph Krausse
// File Created on 1/7/96 11:02:00 AM

#include <stdlib.h>
#include <direct.h>
#include <string.h>

#define IDM_ABOUT         100
#define IDM_SHOWINFO      101

//This struct is what gets passed to the functions 
//declared below. All fields must be filled out

typedef struct tagAppInfo  
{
     int bOverWriteSeal;      // flag to over-write current seal
     char szMagicString[20];  // magic string, this string detects the seal if there is one
     char szAppName[260];     // Your magic string
} APPINFO, *pAPPINFO, far *lpAPPINFO;

//WinExample struct.......... 
typedef struct WinExample
{
    int bWinNT;
    int bWin95;
    int bWin31;
    long  dtExpirationDate;
    char szCompany[60];
    char szName[40];
    char szMagicString[20];
}WINEXAMPLE;


typedef struct tagVersion
{
     int iMajor;  // Major version
     int iMinor;  // Minor version
     int iPatch;  // patch version
     int bBeta;   // is version a beta?
} VERSION,*pVERSION,far *lpVERSION;

/******************
* Declarations... *
******************/

void GetSealError (int wErr,char *szErrorString);
int ValidateApplication (lpAPPINFO lpAppInfo, int wSealBufferLen, void *vpSealBuffer);
int SealApplication(lpAPPINFO lpAppInfo, int wBufferLen);
int InitializeBuffer(int wLen);
void SaveInt(int wValue);
void SaveLong(long lValue);
void SaveString(char *szValue,int wLen);
void DeInitializeBuffer(void);
void GetAPIVersion(lpVERSION lpVersion);

int PASCAL WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
BOOL InitApplication(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
LRESULT FAR PASCAL MainWndProc(HWND, UINT, WPARAM, LPARAM); 
BOOL FAR PASCAL About(HWND, WORD, WPARAM, LPARAM); 
BOOL InitValidation(void);
