Option Explicit

Type rect
    left As Integer
    top As Integer
    right As Integer
    bottom As Integer
End Type

Global Const SM_CYSCREEN = 1
Global Const SM_CXSCREEN = 0
Declare Function GetSystemMetrics Lib "User" (ByVal nIndex As Integer) As Integer
'Declare Function openfile Lib "Kernel" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Integer) As Integer
Declare Sub GetWindowRect Lib "User" (ByVal hWnd As Integer, lpRect As rect)
Declare Sub OffsetRect Lib "User" (lpRect As rect, ByVal x As Integer, ByVal y As Integer)
Declare Sub MoveWindow Lib "User" (ByVal hWnd As Integer, ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal bRepaint As Integer)
Declare Function WinExec Lib "Kernel" (ByVal lpCmdLine As String, ByVal nCmdShow As Integer) As Integer
Global Const SW_SHOW = 5


Sub CenterPopUpWindow (frm As Form)
    'CenterPopUpWindow take the window handle and centers the dialog box
    Dim void%, lpRect As rect
    GetWindowRect frm.hWnd, lpRect
    OffsetRect lpRect, -lpRect.left, -lpRect.top
    MoveWindow frm.hWnd, ((GetSystemMetrics(SM_CXSCREEN) - lpRect.right) / 2), (GetSystemMetrics(SM_CYSCREEN) - lpRect.bottom) / 2, lpRect.right, lpRect.bottom, 0
End Sub

